/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.system.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.system.vo.AccountMasterCardVo;

/**
 * @author yoshida
 *
 */
public class AccountMasterCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_ACCOUNT_MASTER_CARD_SHOW	= "S2405";
	private static final String	CMD_ACCOUNT_MASTER_CARD_SELECT	= "S2406";
	private static final String	CMD_ACCOUNT_MASTER_CARD_INSERT	= "S2407";
	private static final String	CMD_ACCOUNT_MASTER_CARD_UPDATE	= "S2408";
	

	/**
	 * コンストラクタ
	 */
	public AccountMasterCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_SHOW)) {
			show();
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_SELECT)) {
			select();
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new AccountMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		/*						
		 *  	2009/01/09	k.taniai	メニューアレンジ対応
		 */
		vo.aryPltAuthority = StringUtil.combineArray(getCodeArray(CommonConst.TID_AUTHORITY), getArrangeAuthArray());
	}
	
	@Override
	protected void show() {
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		vo.setDefaultValues();
	}
	
	@Override
	protected void select() throws Exception {
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		// データの取得
		CmUserDto dto = part().mospuser().getMosPUserDao().findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		setMode();
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		CmUserDto dto = new CmUserDto();
		vo.setDtoFields(dto);
		dto.setPassword(MospUtility.getDigest(MospUtility.getDigest(dto.getUserId())));
		dto.setKCode("");
		dto.setChangePass(new Date());
		// DAOの準備
		MosPUserDao dao = part().mospuser().getMosPUserDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getUserId()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		CmUserDto retDto = dao.findForKey(dto.getUserId());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		CmUserDto dto = (CmUserDto)getSessionDto();
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		MosPUserDao dao = part().mospuser().getMosPUserDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getUserId()));
		// データの更新
		dao.update(dto, true);
		// DTOの再取得
		CmUserDto retDto = dao.findForKey(dto.getUserId());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// VOのモード設定
		setMode();
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * モード設定
	 * @throws Exception  	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		AccountMasterCardVo vo = (AccountMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(AccountMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(AccountMasterCardVo.MODE_UPDATE);
		}
	}
	
}
